<?php

//////////////////////////////////////////////////////////////////////////////////////////
///
/// SIQUANDO Shop 9
/// SIQUANDO GmbH & Co. KG
/// Autor: Volker Sauer, Am Bugapark 183, 45899 Gelsenkirchen
///
/// $Id: formgateway.ccml 820 2022-11-21 11:50:34Z volker $
///
//////////////////////////////////////////////////////////////////////////////////////////

function postvars($key) {

	// Liefert die POST-Variablen

	if (isset($_POST[$key])) {
		return ($_POST[$key]);
	}
	else {
		return ("");
	}
}

function my_quoted_printable_encode($input) {

	// MIME-Encoding

    $line_max = 76;
	$hex = array('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
	$lines = explode("\r\n", $input);
	$eol = "\r\n";
	$escape = "=";
	$output = "";

	for ($j=0;$j<count($lines);$j++) {
		$line = $lines[$j];
		$linlen = strlen($line);
		$newline = "";
		for($i = 0; $i < $linlen; $i++) {
			$c = substr($line, $i, 1);
			$dec = ord($c);
			if ( ($dec == 32) && ($i == ($linlen - 1)) ) {
				$c = "=20";
			} elseif ( ($dec == 61) || ($dec==46) || ($dec < 32 ) || ($dec > 126) ) {
				$h2 = floor($dec/16); $h1 = floor($dec%16);
				$c = $escape.$hex["$h2"].$hex["$h1"];
			}
			if ( (strlen($newline) + strlen($c)) >= $line_max ) {
				$output .= $newline.$escape.$eol;
				$newline = "";
			}
			$newline .= $c;
		}
		$output .= $newline;
		if ($j<count($lines)-1) $output .= $eol;
	}
	return trim($output);
}

function createHTMLMail() {

	// erzeugt eine HTML-Mail

	reset($_POST);

	$i=1;

	$mymail="";

	// Header

	$mymail.= "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">\r\n";
	$mymail.= "<html>\r\n";
	$mymail.= "<head>\r\n";

	$mymail.="<META http-equiv=Content-Type content=text/html; charset=iso-8859-1>\r\n";

	$mymail.= "</head>\r\n";
	$mymail.= "<body bgcolor=\"#ffffff\" text=\"#333333\" link=\"#333333\">\r\n";

	$mymail.= "<style>\r\n";
	$mymail.= "  td {font-family : Tahoma, Verdana, Geneva, Arial, Helvetica, sans-serif; font-size : 11px; color : #333333; }\r\n";
	$mymail.= "</style>\r\n";
	$mymail.="<table width=100% border=0 cellpadding=4>\r\n";

	$mymail.="<tr>";
	$mymail.='<td colspan=2><strong>You received the following message:</strong></td>'."\r\n";
	$mymail.="</tr>\r\n";
	
	foreach($_POST as $key => $val) {
		switch ($key)
		{
			case "x":
			case "y":
			case "fgwemail":
			case "fgwsubject":
			case "fgwreturnurl":
			case "fgwcaptchacode":
			case "fgwcaptchaid":
			case "fgwuid":
				break;
	   		default:
				$mymail.="<tr>";
				$mymail.="<td><strong>".$key.":</strong></td>\r\n";
				$mymail.="<td width=100%>".$val."</td>\r\n";
				$mymail.="</tr>\r\n";
		}
	}

	$mymail.="</table>\r\n";

	return $mymail;
}

function createTextMail() {

	$mymail="";
	foreach($_POST as $key => $val) {
		switch ($key)
		{
			case "x":
			case "y":
			case "fgwemail":
			case "fgwsubject":
			case "fgwreturnurl":
			case "fgwcaptchacode":
			case "fgwcaptchaid":
			case "fgwuid":
				break;
	   		default:
				$mymail.=$key.": ";
				$mymail.=$val."\r\n\r\n";
		}
	}

	$mymail.="\r\n\r\n";

	return $mymail;
}

function createMimeMail() {
	global $inner;

	$mymime="This is a multi-part message in MIME format.\r\n\r\n";

	//////////////////////////////////////////////////////////////////////////
	//
	// nderungen File Upload
	// etor e.K. 31.07.2008
	// START
	//

	// Uploads
	if (count($_FILES)) {
		$mymimeuploads = '';
		foreach($_FILES as $upload)
			if ($upload['error'] == UPLOAD_ERR_OK && is_uploaded_file($upload['tmp_name'])) {
				$mymimeuploads.="----WEB2DATEGATEWAY\r\n";
				$mymimeuploads.="Content-Type: ".$upload['type'].";\r\n\tname=\"".$upload['name']."\"\r\n";
				$mymimeuploads.="Content-Transfer-Encoding: base64\r\n";
				$mymimeuploads.="Content-Disposition: attachment;\r\n\tfilename=\"".$upload['name']."\"\r\n\r\n";
				$mymimeuploads.=chunk_split(base64_encode(file_get_contents($upload['tmp_name'])), 76, "\r\n")."\r\n";
				$inner = "INNER";
			}
	}

	// Falls Upload verschachteln
	if ($inner) {
		$mymime.="----WEB2DATEGATEWAY\r\n";
		$mymime.="Content-Type: multipart/alternative;\r\n\tboundary=\"--INNERWEB2DATEGATEWAY\"\r\n\r\n";
	}

	// Text und HTML Teil, ggf. innerhalb eines weiteren multiparts
	$mymime.="----".$inner."WEB2DATEGATEWAY\r\n";
	$mymime.="Content-Type: text/plain;\r\n\tcharset=\"iso-8859-1\"\r\n";
	$mymime.="Content-Transfer-Encoding: quoted-printable\r\n\r\n";
	$mymime.=my_quoted_printable_encode(createTextMail())."\r\n";
	$mymime.="----".$inner."WEB2DATEGATEWAY\r\n";
	$mymime.="Content-Type: text/html;\r\n\tcharset=\"iso-8859-1\"\r\n";
	$mymime.="Content-Transfer-Encoding: quoted-printable\r\n\r\n";
	$mymime.=my_quoted_printable_encode(createHTMLMail())."\r\n";
	$mymime.="----".$inner."WEB2DATEGATEWAY--\r\n";

	// Falls verschachtelt, Uploads einfgen und Ende vom usseren Multipart
	if ($inner) {
		$mymime .= $mymimeuploads;
		$mymime.="----WEB2DATEGATEWAY--\r\n";
	}

	//
	// ENDE
	//////////////////////////////////////////////////////////////////////////

	return $mymime;
}

function deSlash(&$element) {

	// Fr Stripslash

	$element=stripslashes($element);
}

// Hauptprogramm

@ini_set('default_charset','ISO-8859-1');

//////////////////////////////////////////////////////////////////////////
//
// nderungen Email
// etor e.K. 29.04.2009
//

$fgwemailuid=postVars("fgwemail");

//
//////////////////////////////////////////////////////////////////////////

$fgwsubject=postVars("fgwsubject");
$fgwreturnurl=postVars("fgwreturnurl");
$fgwuid=postVars("fgwuid");
$fgwcaptchaid=postVars('fgwcaptchaid');
$fgwcaptchacode=postVars('fgwcaptchacode');

$whitelist=array();
$captchauids=array();

//////////////////////////////////////////////////////////////////////////
//
// nderungen Email
// etor e.K. 29.04.2009
//

$fgwemail = isset($whitelist[$fgwemailuid]) ? $whitelist[$fgwemailuid] : null;

//
//////////////////////////////////////////////////////////////////////////

if ($fgwemail!='nomail@kaufrausch.de') {

	if (in_array($fgwuid,$captchauids)) {
		include('./assets/');
		$captcha=new captchas();
		$captcha->datapath='./assets/plugindata/';
		if (!$captcha->checkticket($fgwcaptchaid,$fgwcaptchacode)) {
			die("ERROR: BAD CAPTCHA");
		}
	}

	//////////////////////////////////////////////////////////////////////////
	//
	// nderungen Email
	// etor e.K. 29.04.2009
	//

	if (!$fgwemailuid) {
		die ("ERROR: NO RETURN-EMAIL-ADDRESS-UID");
	}

	if (!$fgwemail) {
		die("ERROR: ILLEGAL RETURN-EMAIL-ADDRESS-UID");
	}

	//
	//////////////////////////////////////////////////////////////////////////

	if (!$fgwreturnurl) {
		die ("ERROR: NO RETURN-URL");
	}

	$from = $fgwemail;
	$reply_to = null;
	if (isset($_POST['email'])) {
		$email = trim($_POST['email']);
		$regex = '/^((\"[^\"\f\n\r\t\v\b]+\")|([\w\!\#\$\%\&\'\*\+\-\~\/\^\`\|\{\}]+(\.[\w\!\#\$\%\&\'\*\+\-\~\/\^\`\|\{\}]+)*))@((\[(((25[0-5])|(2[0-4][0-9])|([0-1]?[0-9]?[0-9]))\.((25[0-5])|(2[0-4][0-9])|([0-1]?[0-9]?[0-9]))\.((25[0-5])|(2[0-4][0-9])|([0-1]?[0-9]?[0-9]))\.((25[0-5])|(2[0-4][0-9])|([0-1]?[0-9]?[0-9])))\])|(((25[0-5])|(2[0-4][0-9])|([0-1]?[0-9]?[0-9]))\.((25[0-5])|(2[0-4][0-9])|([0-1]?[0-9]?[0-9]))\.((25[0-5])|(2[0-4][0-9])|([0-1]?[0-9]?[0-9]))\.((25[0-5])|(2[0-4][0-9])|([0-1]?[0-9]?[0-9])))|((([A-Za-z0-9\-])+\.)+[A-Za-z\-]+))$/D';
		if (preg_match($regex, $email)) {
			$reply_to = $email;
		}
	}

	@mail ($fgwemail, $fgwsubject, createMimeMail(),
		"From: $from\r\n" .
		($reply_to ? "Reply-To: $reply_to\r\n" : '') . 
		"MIME-Version: 1.0\r\n" . 
		"Content-Type: multipart/".(isset($inner) ? 'mixed' : 'alternative').";\r\n" . 
		"\tboundary=\"--WEB2DATEGATEWAY\"\r\n" . 
		"X-Mailer: SIQUANDO Web Gateway Version 1.1");
}

header("Location: ".$fgwreturnurl);

?>
